﻿using System;
using System.Diagnostics;

namespace TestDockerProcess
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private
        ////////////////////////////////////////////////////////////////////// Event

        #region 프로세스 종료시 처리하기 - process_Exited(sender, e)

        /// <summary>
        /// 프로세스 종료시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private static void process_Exited(object sender, EventArgs e)
        {
            Process process = sender as Process;

            Console.WriteLine("종료 코드 : {0}", process.ExitCode);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////// Function

        #region 프로그램 실행하기 - Main()

        /// <summary>
        /// 프로그램 실행하기
        /// </summary>
        private static void Main()
        {
            Console.WriteLine("도커 프로세스를 실행합니다.");

            string argument = string.Format
            (
                "container run -itd -v {0} --rm {1} {2} \"{3}\"",
                "d:/ServiceRoot:c:/ServiceRoot",                                                   // 호스트 디렉토리와 컨테이너 디렉토리 공유
                "testconsole",                                                                     // 이미지
                "testconsole.exe",                                                                 // 실행 명령
                @"c:\ServiceRoot\TMP\TMP_DEV\ServiceHost\Data\20190222\JOBKEY0001\JOBKEY0001.json" // 실행 명령 인자
            );

            Process process = new Process();

            process.EnableRaisingEvents   = true;
            process.StartInfo.FileName    = "docker.exe";
            process.StartInfo.Verb        = "Open";
            process.StartInfo.WindowStyle = ProcessWindowStyle.Hidden;
            process.StartInfo.Arguments   = argument;

            process.Exited += process_Exited;

            process.Start();

            process.WaitForExit();

            Console.WriteLine("도커 프로세스 실행을 종료했습니다.");
        }

        #endregion
    }
}